<html>
<head>
<title>Ogre::RTShader::ProgramManager Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="namespaceOgre_1_1RTShader.html">RTShader</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html">ProgramManager</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#pro-static-attribs">Static Protected Attributes</a> &#124;
<a href="#friends">Friends</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RTShader::ProgramManager Class Reference<div class="ingroups"><a class="el" href="group__RTShader.html">RTShader</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RTShader::ProgramManager" --><!-- doxytag: inherits="Singleton&lt; ProgramManager &gt;,Ogre::AllocatedObject" -->
<p>A singleton manager class that manages shader based programs.  
 <a href="classOgre_1_1RTShader_1_1ProgramManager.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::RTShader::ProgramManager:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1RTShader_1_1ProgramManager__inherit__graph.gif" border="0" usemap="#Ogre_1_1RTShader_1_1ProgramManager_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1RTShader_1_1ProgramManager_inherit__map" id="Ogre_1_1RTShader_1_1ProgramManager_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1Singleton.html" title="Ogre::Singleton\&lt; ProgramManager \&gt;" alt="" coords="5,5,240,35"/><area shape="rect" id="node4" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="264,5,419,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1RTShader_1_1ProgramManager-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a7b4f84219b1785a296bbb6650b383b7d">ProgramManager</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class default constructor.  <a href="#a7b4f84219b1785a296bbb6650b383b7d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a4f5a2008055d0665367504ad17961bd2">~ProgramManager</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class destructor.  <a href="#a4f5a2008055d0665367504ad17961bd2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a006134915dcf987f1b7f52c4aeefe9b0">acquirePrograms</a> (<a class="el" href="classOgre_1_1Pass.html">Pass</a> *pass, <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html">TargetRenderState</a> *renderState)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Acquire CPU/GPU programs set associated with the given render state and bind them to the pass.  <a href="#a006134915dcf987f1b7f52c4aeefe9b0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a8bc53f45e45d99b5bcf0634079b919a4">releasePrograms</a> (<a class="el" href="classOgre_1_1Pass.html">Pass</a> *pass, <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html">TargetRenderState</a> *renderState)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Release CPU/GPU programs set associated with the given render state and pass.  <a href="#a8bc53f45e45d99b5bcf0634079b919a4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a5fada758d802476e4c2a56f7ffa8e9cb">flushGpuProgramsCache</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Flush the local GPU programs cache.  <a href="#a5fada758d802476e4c2a56f7ffa8e9cb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html">ProgramManager</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a9c7937d342955ee45a30d2926ffebd0b">getSingleton</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval.  <a href="#a9c7937d342955ee45a30d2926ffebd0b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html">ProgramManager</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a77da1fe51136be09e702e698092b2185">getSingletonPtr</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval.  <a href="#a77da1fe51136be09e702e698092b2185"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt; <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <br class="typebreak"/>
<a class="el" href="classOgre_1_1GpuProgramPtr.html">GpuProgramPtr</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6cb4798f70d8d155a8fd38b3dc90db6f">GpuProgramsMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef GpuProgramsMap::iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a5b56328823eb9ab9d39823bfa2aa5746">GpuProgramsMapIterator</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <br class="typebreak"/>
GpuProgramsMap::const_iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a399fd8dd25b5dd01096adcca41f584a9">GpuProgramsMapConstIterator</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1set.html">set</a>&lt; <a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> * &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a0f7df7b3bdf120c0b4e1f2fd69db5c99">ProgramList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef ProgramList::iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#ae67ddfab3decd1b3823b2ba7de86d964">ProgramListIterator</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt; <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <br class="typebreak"/>
<a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html">ProgramWriter</a> * &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#ae5169c232806b070eb8983949fb2645b">ProgramWriterMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef ProgramWriterMap::iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a516c14e5e1624f33e204e30d0f5d91b4">ProgramWriterIterator</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a><br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriterFactory.html">ProgramWriterFactory</a> * &gt;<br class="typebreak"/>
::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#aef888e5ad925de6207cb5da3cad588f1">ProgramWriterFactoryList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt; <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <br class="typebreak"/>
<a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html">ProgramProcessor</a> * &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a587dec8ae6e0c2dfbdd2751da80549d6">ProgramProcessorMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <br class="typebreak"/>
ProgramProcessorMap::iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a09f6ad3178b190ca76bb5d6c3b5d1539">ProgramProcessorIterator</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <br class="typebreak"/>
ProgramProcessorMap::const_iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a828c6453d29c03242d8c2f8872048d4a">ProgramProcessorConstIterator</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a><br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html">ProgramProcessor</a> * &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#aef6274f2febcceddbbf9e7cff003431d">ProgramProcessorList</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6d6193af5b9a370a3ead0316428dfaef">createDefaultProgramProcessors</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create default program processors.  <a href="#a6d6193af5b9a370a3ead0316428dfaef"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a681927a127f2d66dd66a5fbc333b0ce6">destroyDefaultProgramProcessors</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy default program processors.  <a href="#a681927a127f2d66dd66a5fbc333b0ce6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a97ea0cc68b8474d3a80e9258670bfdb1">createDefaultProgramWriterFactories</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create default program processors.  <a href="#a97ea0cc68b8474d3a80e9258670bfdb1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a663b9c20dde73b748bdeaad3f4eb5672">destroyDefaultProgramWriterFactories</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy default program processors.  <a href="#a663b9c20dde73b748bdeaad3f4eb5672"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a9dd91c5604e22f21171c8cbc211ae934">destroyProgramWriters</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy all program writers.  <a href="#a9dd91c5604e22f21171c8cbc211ae934"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#ac5e8803727ad1b7f6dba7dee7b58a03c">createCpuProgram</a> (<a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a> type)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create CPU program .  <a href="#ac5e8803727ad1b7f6dba7dee7b58a03c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#ae9565d0d1f78ec6f69f62b02121c2e9b">destroyCpuProgram</a> (<a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *shaderProgram)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy a CPU program by name.  <a href="#ae9565d0d1f78ec6f69f62b02121c2e9b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#aaaeedbf9489bb8b69af914929b87c685">createGpuPrograms</a> (<a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *programSet)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create GPU programs for the given program set based on the CPU programs it contains.  <a href="#aaaeedbf9489bb8b69af914929b87c685"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GpuProgramPtr.html">GpuProgramPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a8a42103189758f996588453c9de45733">createGpuProgram</a> (<a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *shaderProgram, <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html">ProgramWriter</a> *programWriter, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;language, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;profiles, const <a class="el" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> &amp;profilesList, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;cachePath)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create GPU program based on the give CPU program.  <a href="#a8a42103189758f996588453c9de45733"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a18c1dfd3ed3a29cc01c48e768d00a80b">addProgramProcessor</a> (<a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html">ProgramProcessor</a> *processor)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add program processor instance to this manager.  <a href="#a18c1dfd3ed3a29cc01c48e768d00a80b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a21a68f67aa6c2426fd979d21cbfc10d5">removeProgramProcessor</a> (<a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html">ProgramProcessor</a> *processor)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove program processor instance from this manager.  <a href="#a21a68f67aa6c2426fd979d21cbfc10d5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#ae37c02b81002bd0d86d969768bf5b344">destroyGpuProgram</a> (<a class="el" href="classOgre_1_1GpuProgramPtr.html">GpuProgramPtr</a> &amp;gpuProgram)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy a GPU program by name.  <a href="#ae37c02b81002bd0d86d969768bf5b344"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#add918305ce36509190b617cc691d73e8">flushGpuProgramsCache</a> (<a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6cb4798f70d8d155a8fd38b3dc90db6f">GpuProgramsMap</a> &amp;gpuProgramsMap)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Flush the local GPU programs cache.  <a href="#add918305ce36509190b617cc691d73e8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6520a083063012966afc4bdd4b7e8b56">getVertexShaderCount</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the number of created vertex shaders.  <a href="#a6520a083063012966afc4bdd4b7e8b56"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#ada664dc10866e58c9825b70cdbe333e4">getFragmentShaderCount</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the number of created fragment shaders.  <a href="#ada664dc10866e58c9825b70cdbe333e4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a58647b2385590ef34b0a1ee3a8dfc770">synchronizePixelnToBeVertexOut</a> (<a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *programSet)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Fix the input of the pixel shader to be the same as the output of the vertex shader.  <a href="#a58647b2385590ef34b0a1ee3a8dfc770"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a36c51904811a224420d0a0ec212819f8">bindUniformParameters</a> (<a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *pCpuProgram, const <a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a> &amp;passParams)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Bind the uniform parameters of a given CPU and GPU program set.  <a href="#a36c51904811a224420d0a0ec212819f8"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a0f7df7b3bdf120c0b4e1f2fd69db5c99">ProgramList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a774e21edb65ca869e2d7fc5d39514bfa">mCpuProgramsList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#ae5169c232806b070eb8983949fb2645b">ProgramWriterMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#af3058fc76343ef0a2e4490d7ff7409e3">mProgramWritersMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a587dec8ae6e0c2dfbdd2751da80549d6">ProgramProcessorMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#afb4dc08057dbac666effe79c14541441">mProgramProcessorsMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#aef888e5ad925de6207cb5da3cad588f1">ProgramWriterFactoryList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a261d632268e484e4e29038488c3c82c4">mProgramWriterFactories</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6cb4798f70d8d155a8fd38b3dc90db6f">GpuProgramsMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a91ebd2a26c267914c4dbec827786ef65">mVertexShaderMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6cb4798f70d8d155a8fd38b3dc90db6f">GpuProgramsMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a115511b28b8ad14d77df7e1d15691588">mFragmentShaderMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#aef6274f2febcceddbbf9e7cff003431d">ProgramProcessorList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#affb5afbd04566b7039f60bfd0f3b9bf2">mDefaultProgramProcessors</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-static-attribs"></a>
Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html">ProgramManager</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">msSingleton</a></td></tr>
<tr><td colspan="2"><h2><a name="friends"></a>
Friends</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#af4cc94a00f22d3cc0d2408ba30a9a141">ProgramSet</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#af6e59fb08a915c63d07d3e1a1a4f1092">TargetRenderState</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#adcb2ff432738c3d0e602910347d3785a">ShaderGenerator</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>A singleton manager class that manages shader based programs. </p>

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00046">46</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="a6cb4798f70d8d155a8fd38b3dc90db6f"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::GpuProgramsMap" ref="a6cb4798f70d8d155a8fd38b3dc90db6f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt;<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <a class="el" href="classOgre_1_1GpuProgramPtr.html">GpuProgramPtr</a>&gt;::type <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6cb4798f70d8d155a8fd38b3dc90db6f">Ogre::RTShader::ProgramManager::GpuProgramsMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00111">111</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a399fd8dd25b5dd01096adcca41f584a9"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::GpuProgramsMapConstIterator" ref="a399fd8dd25b5dd01096adcca41f584a9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef GpuProgramsMap::const_iterator <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a399fd8dd25b5dd01096adcca41f584a9">Ogre::RTShader::ProgramManager::GpuProgramsMapConstIterator</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00113">113</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a5b56328823eb9ab9d39823bfa2aa5746"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::GpuProgramsMapIterator" ref="a5b56328823eb9ab9d39823bfa2aa5746" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef GpuProgramsMap::iterator <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a5b56328823eb9ab9d39823bfa2aa5746">Ogre::RTShader::ProgramManager::GpuProgramsMapIterator</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00112">112</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a0f7df7b3bdf120c0b4e1f2fd69db5c99"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::ProgramList" ref="a0f7df7b3bdf120c0b4e1f2fd69db5c99" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1set.html">set</a>&lt;<a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a>*&gt;::type <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a0f7df7b3bdf120c0b4e1f2fd69db5c99">Ogre::RTShader::ProgramManager::ProgramList</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00116">116</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae67ddfab3decd1b3823b2ba7de86d964"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::ProgramListIterator" ref="ae67ddfab3decd1b3823b2ba7de86d964" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef ProgramList::iterator <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#ae67ddfab3decd1b3823b2ba7de86d964">Ogre::RTShader::ProgramManager::ProgramListIterator</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00117">117</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a828c6453d29c03242d8c2f8872048d4a"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::ProgramProcessorConstIterator" ref="a828c6453d29c03242d8c2f8872048d4a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef ProgramProcessorMap::const_iterator <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a828c6453d29c03242d8c2f8872048d4a">Ogre::RTShader::ProgramManager::ProgramProcessorConstIterator</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00125">125</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a09f6ad3178b190ca76bb5d6c3b5d1539"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::ProgramProcessorIterator" ref="a09f6ad3178b190ca76bb5d6c3b5d1539" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef ProgramProcessorMap::iterator <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a09f6ad3178b190ca76bb5d6c3b5d1539">Ogre::RTShader::ProgramManager::ProgramProcessorIterator</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00124">124</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="aef6274f2febcceddbbf9e7cff003431d"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::ProgramProcessorList" ref="aef6274f2febcceddbbf9e7cff003431d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html">ProgramProcessor</a>*&gt;::type <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#aef6274f2febcceddbbf9e7cff003431d">Ogre::RTShader::ProgramManager::ProgramProcessorList</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00126">126</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a587dec8ae6e0c2dfbdd2751da80549d6"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::ProgramProcessorMap" ref="a587dec8ae6e0c2dfbdd2751da80549d6" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt;<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html">ProgramProcessor</a>*&gt;::type <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a587dec8ae6e0c2dfbdd2751da80549d6">Ogre::RTShader::ProgramManager::ProgramProcessorMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00123">123</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="aef888e5ad925de6207cb5da3cad588f1"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::ProgramWriterFactoryList" ref="aef888e5ad925de6207cb5da3cad588f1" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="classOgre_1_1RTShader_1_1ProgramWriterFactory.html">ProgramWriterFactory</a>*&gt;::type <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#aef888e5ad925de6207cb5da3cad588f1">Ogre::RTShader::ProgramManager::ProgramWriterFactoryList</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00120">120</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a516c14e5e1624f33e204e30d0f5d91b4"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::ProgramWriterIterator" ref="a516c14e5e1624f33e204e30d0f5d91b4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef ProgramWriterMap::iterator <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a516c14e5e1624f33e204e30d0f5d91b4">Ogre::RTShader::ProgramManager::ProgramWriterIterator</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00119">119</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae5169c232806b070eb8983949fb2645b"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::ProgramWriterMap" ref="ae5169c232806b070eb8983949fb2645b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt;<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html">ProgramWriter</a>*&gt;::type <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#ae5169c232806b070eb8983949fb2645b">Ogre::RTShader::ProgramManager::ProgramWriterMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00118">118</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a7b4f84219b1785a296bbb6650b383b7d"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::ProgramManager" ref="a7b4f84219b1785a296bbb6650b383b7d" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a7b4f84219b1785a296bbb6650b383b7d">Ogre::RTShader::ProgramManager::ProgramManager</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class default constructor. </p>

</div>
</div>
<a class="anchor" id="a4f5a2008055d0665367504ad17961bd2"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::~ProgramManager" ref="a4f5a2008055d0665367504ad17961bd2" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a4f5a2008055d0665367504ad17961bd2">Ogre::RTShader::ProgramManager::~ProgramManager</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class destructor. </p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a006134915dcf987f1b7f52c4aeefe9b0"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::acquirePrograms" ref="a006134915dcf987f1b7f52c4aeefe9b0" args="(Pass *pass, TargetRenderState *renderState)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a006134915dcf987f1b7f52c4aeefe9b0">Ogre::RTShader::ProgramManager::acquirePrograms</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&#160;</td>
          <td class="paramname"><em>pass</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html">TargetRenderState</a> *&#160;</td>
          <td class="paramname"><em>renderState</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Acquire CPU/GPU programs set associated with the given render state and bind them to the pass. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">pass</td><td>The pass to bind the programs to. </td></tr>
    <tr><td class="paramname">renderState</td><td>The render state that describes the program that need to be generated. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a18c1dfd3ed3a29cc01c48e768d00a80b"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::addProgramProcessor" ref="a18c1dfd3ed3a29cc01c48e768d00a80b" args="(ProgramProcessor *processor)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a18c1dfd3ed3a29cc01c48e768d00a80b">Ogre::RTShader::ProgramManager::addProgramProcessor</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html">ProgramProcessor</a> *&#160;</td>
          <td class="paramname"><em>processor</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add program processor instance to this manager. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">processor</td><td>The instance to add. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a36c51904811a224420d0a0ec212819f8"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::bindUniformParameters" ref="a36c51904811a224420d0a0ec212819f8" args="(Program *pCpuProgram, const GpuProgramParametersSharedPtr &amp;passParams)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a36c51904811a224420d0a0ec212819f8">Ogre::RTShader::ProgramManager::bindUniformParameters</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>pCpuProgram</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>passParams</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Bind the uniform parameters of a given CPU and GPU program set. </p>

</div>
</div>
<a class="anchor" id="ac5e8803727ad1b7f6dba7dee7b58a03c"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::createCpuProgram" ref="ac5e8803727ad1b7f6dba7dee7b58a03c" args="(GpuProgramType type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a>* <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#ac5e8803727ad1b7f6dba7dee7b58a03c">Ogre::RTShader::ProgramManager::createCpuProgram</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a>&#160;</td>
          <td class="paramname"><em>type</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create CPU program . </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">type</td><td>The type of the program to create. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a6d6193af5b9a370a3ead0316428dfaef"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::createDefaultProgramProcessors" ref="a6d6193af5b9a370a3ead0316428dfaef" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6d6193af5b9a370a3ead0316428dfaef">Ogre::RTShader::ProgramManager::createDefaultProgramProcessors</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create default program processors. </p>

</div>
</div>
<a class="anchor" id="a97ea0cc68b8474d3a80e9258670bfdb1"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::createDefaultProgramWriterFactories" ref="a97ea0cc68b8474d3a80e9258670bfdb1" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a97ea0cc68b8474d3a80e9258670bfdb1">Ogre::RTShader::ProgramManager::createDefaultProgramWriterFactories</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create default program processors. </p>

</div>
</div>
<a class="anchor" id="a8a42103189758f996588453c9de45733"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::createGpuProgram" ref="a8a42103189758f996588453c9de45733" args="(Program *shaderProgram, ProgramWriter *programWriter, const String &amp;language, const String &amp;profiles, const StringVector &amp;profilesList, const String &amp;cachePath)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GpuProgramPtr.html">GpuProgramPtr</a> <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a8a42103189758f996588453c9de45733">Ogre::RTShader::ProgramManager::createGpuProgram</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>shaderProgram</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html">ProgramWriter</a> *&#160;</td>
          <td class="paramname"><em>programWriter</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>language</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>profiles</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> &amp;&#160;</td>
          <td class="paramname"><em>profilesList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>cachePath</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create GPU program based on the give CPU program. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">shaderProgram</td><td>The CPU program instance. </td></tr>
    <tr><td class="paramname">programWriter</td><td>The program writer instance. </td></tr>
    <tr><td class="paramname">language</td><td>The target shader language. </td></tr>
    <tr><td class="paramname">profiles</td><td>The profiles string for program compilation. </td></tr>
    <tr><td class="paramname">profiles</td><td>The profiles string for program compilation as string list. </td></tr>
    <tr><td class="paramname">cachePath</td><td>The output path to write the program into. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aaaeedbf9489bb8b69af914929b87c685"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::createGpuPrograms" ref="aaaeedbf9489bb8b69af914929b87c685" args="(ProgramSet *programSet)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#aaaeedbf9489bb8b69af914929b87c685">Ogre::RTShader::ProgramManager::createGpuPrograms</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *&#160;</td>
          <td class="paramname"><em>programSet</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create GPU programs for the given program set based on the CPU programs it contains. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">programSet</td><td>The program set container. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ae9565d0d1f78ec6f69f62b02121c2e9b"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::destroyCpuProgram" ref="ae9565d0d1f78ec6f69f62b02121c2e9b" args="(Program *shaderProgram)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#ae9565d0d1f78ec6f69f62b02121c2e9b">Ogre::RTShader::ProgramManager::destroyCpuProgram</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>shaderProgram</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Destroy a CPU program by name. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">shaderProgram</td><td>The CPU program instance to destroy. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a681927a127f2d66dd66a5fbc333b0ce6"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::destroyDefaultProgramProcessors" ref="a681927a127f2d66dd66a5fbc333b0ce6" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a681927a127f2d66dd66a5fbc333b0ce6">Ogre::RTShader::ProgramManager::destroyDefaultProgramProcessors</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Destroy default program processors. </p>

</div>
</div>
<a class="anchor" id="a663b9c20dde73b748bdeaad3f4eb5672"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::destroyDefaultProgramWriterFactories" ref="a663b9c20dde73b748bdeaad3f4eb5672" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a663b9c20dde73b748bdeaad3f4eb5672">Ogre::RTShader::ProgramManager::destroyDefaultProgramWriterFactories</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Destroy default program processors. </p>

</div>
</div>
<a class="anchor" id="ae37c02b81002bd0d86d969768bf5b344"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::destroyGpuProgram" ref="ae37c02b81002bd0d86d969768bf5b344" args="(GpuProgramPtr &amp;gpuProgram)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#ae37c02b81002bd0d86d969768bf5b344">Ogre::RTShader::ProgramManager::destroyGpuProgram</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GpuProgramPtr.html">GpuProgramPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>gpuProgram</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Destroy a GPU program by name. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>The name of the program to destroy. </td></tr>
    <tr><td class="paramname">type</td><td>The type of the program to destroy. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a9dd91c5604e22f21171c8cbc211ae934"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::destroyProgramWriters" ref="a9dd91c5604e22f21171c8cbc211ae934" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a9dd91c5604e22f21171c8cbc211ae934">Ogre::RTShader::ProgramManager::destroyProgramWriters</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Destroy all program writers. </p>

</div>
</div>
<a class="anchor" id="a5fada758d802476e4c2a56f7ffa8e9cb"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::flushGpuProgramsCache" ref="a5fada758d802476e4c2a56f7ffa8e9cb" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a5fada758d802476e4c2a56f7ffa8e9cb">Ogre::RTShader::ProgramManager::flushGpuProgramsCache</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Flush the local GPU programs cache. </p>

</div>
</div>
<a class="anchor" id="add918305ce36509190b617cc691d73e8"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::flushGpuProgramsCache" ref="add918305ce36509190b617cc691d73e8" args="(GpuProgramsMap &amp;gpuProgramsMap)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a5fada758d802476e4c2a56f7ffa8e9cb">Ogre::RTShader::ProgramManager::flushGpuProgramsCache</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6cb4798f70d8d155a8fd38b3dc90db6f">GpuProgramsMap</a> &amp;&#160;</td>
          <td class="paramname"><em>gpuProgramsMap</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Flush the local GPU programs cache. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">gpuProgramsMap</td><td>The GPU programs cache. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ada664dc10866e58c9825b70cdbe333e4"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::getFragmentShaderCount" ref="ada664dc10866e58c9825b70cdbe333e4" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#ada664dc10866e58c9825b70cdbe333e4">Ogre::RTShader::ProgramManager::getFragmentShaderCount</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the number of created fragment shaders. </p>

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00202">202</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9c7937d342955ee45a30d2926ffebd0b"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::getSingleton" ref="a9c7937d342955ee45a30d2926ffebd0b" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html">ProgramManager</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a9c7937d342955ee45a30d2926ffebd0b">Ogre::RTShader::ProgramManager::getSingleton</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Why do we do this? Well, it's because the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> template to work, but we actually only want it compiled into the implementation of the class based on the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors. </dd></dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1Singleton.html#a7757bd7ac3702c144502e53ad6491888">Ogre::Singleton&lt; ProgramManager &gt;</a>.</p>

</div>
</div>
<a class="anchor" id="a77da1fe51136be09e702e698092b2185"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::getSingletonPtr" ref="a77da1fe51136be09e702e698092b2185" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html">ProgramManager</a>* <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a77da1fe51136be09e702e698092b2185">Ogre::RTShader::ProgramManager::getSingletonPtr</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Override standard <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> retrieval. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Why do we do this? Well, it's because the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a> template to work, but we actually only want it compiled into the implementation of the class based on the <a class="el" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors. </dd></dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1Singleton.html#a7ab51c46521b89723d6186a52a7e0d7b">Ogre::Singleton&lt; ProgramManager &gt;</a>.</p>

</div>
</div>
<a class="anchor" id="a6520a083063012966afc4bdd4b7e8b56"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::getVertexShaderCount" ref="a6520a083063012966afc4bdd4b7e8b56" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6520a083063012966afc4bdd4b7e8b56">Ogre::RTShader::ProgramManager::getVertexShaderCount</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the number of created vertex shaders. </p>

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00199">199</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8bc53f45e45d99b5bcf0634079b919a4"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::releasePrograms" ref="a8bc53f45e45d99b5bcf0634079b919a4" args="(Pass *pass, TargetRenderState *renderState)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a8bc53f45e45d99b5bcf0634079b919a4">Ogre::RTShader::ProgramManager::releasePrograms</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&#160;</td>
          <td class="paramname"><em>pass</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html">TargetRenderState</a> *&#160;</td>
          <td class="paramname"><em>renderState</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Release CPU/GPU programs set associated with the given render state and pass. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">pass</td><td>The pass to release the programs from. </td></tr>
    <tr><td class="paramname">renderState</td><td>The render state holds the programs. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a21a68f67aa6c2426fd979d21cbfc10d5"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::removeProgramProcessor" ref="a21a68f67aa6c2426fd979d21cbfc10d5" args="(ProgramProcessor *processor)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a21a68f67aa6c2426fd979d21cbfc10d5">Ogre::RTShader::ProgramManager::removeProgramProcessor</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html">ProgramProcessor</a> *&#160;</td>
          <td class="paramname"><em>processor</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove program processor instance from this manager. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">processor</td><td>The instance to remove. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a58647b2385590ef34b0a1ee3a8dfc770"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::synchronizePixelnToBeVertexOut" ref="a58647b2385590ef34b0a1ee3a8dfc770" args="(ProgramSet *programSet)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a58647b2385590ef34b0a1ee3a8dfc770">Ogre::RTShader::ProgramManager::synchronizePixelnToBeVertexOut</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *&#160;</td>
          <td class="paramname"><em>programSet</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Fix the input of the pixel shader to be the same as the output of the vertex shader. </p>

</div>
</div>
<hr/><h2>Friends And Related Function Documentation</h2>
<a class="anchor" id="af4cc94a00f22d3cc0d2408ba30a9a141"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::ProgramSet" ref="af4cc94a00f22d3cc0d2408ba30a9a141" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00224">224</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="adcb2ff432738c3d0e602910347d3785a"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::ShaderGenerator" ref="adcb2ff432738c3d0e602910347d3785a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator.html">ShaderGenerator</a><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00226">226</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="af6e59fb08a915c63d07d3e1a1a4f1092"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::TargetRenderState" ref="af6e59fb08a915c63d07d3e1a1a4f1092" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html">TargetRenderState</a><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00225">225</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a774e21edb65ca869e2d7fc5d39514bfa"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::mCpuProgramsList" ref="a774e21edb65ca869e2d7fc5d39514bfa" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a0f7df7b3bdf120c0b4e1f2fd69db5c99">ProgramList</a> <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a774e21edb65ca869e2d7fc5d39514bfa">Ogre::RTShader::ProgramManager::mCpuProgramsList</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00215">215</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="affb5afbd04566b7039f60bfd0f3b9bf2"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::mDefaultProgramProcessors" ref="affb5afbd04566b7039f60bfd0f3b9bf2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#aef6274f2febcceddbbf9e7cff003431d">ProgramProcessorList</a> <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#affb5afbd04566b7039f60bfd0f3b9bf2">Ogre::RTShader::ProgramManager::mDefaultProgramProcessors</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00221">221</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a115511b28b8ad14d77df7e1d15691588"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::mFragmentShaderMap" ref="a115511b28b8ad14d77df7e1d15691588" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6cb4798f70d8d155a8fd38b3dc90db6f">GpuProgramsMap</a> <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a115511b28b8ad14d77df7e1d15691588">Ogre::RTShader::ProgramManager::mFragmentShaderMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00220">220</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="afb4dc08057dbac666effe79c14541441"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::mProgramProcessorsMap" ref="afb4dc08057dbac666effe79c14541441" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a587dec8ae6e0c2dfbdd2751da80549d6">ProgramProcessorMap</a> <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#afb4dc08057dbac666effe79c14541441">Ogre::RTShader::ProgramManager::mProgramProcessorsMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00217">217</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a261d632268e484e4e29038488c3c82c4"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::mProgramWriterFactories" ref="a261d632268e484e4e29038488c3c82c4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#aef888e5ad925de6207cb5da3cad588f1">ProgramWriterFactoryList</a> <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a261d632268e484e4e29038488c3c82c4">Ogre::RTShader::ProgramManager::mProgramWriterFactories</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00218">218</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="af3058fc76343ef0a2e4490d7ff7409e3"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::mProgramWritersMap" ref="af3058fc76343ef0a2e4490d7ff7409e3" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#ae5169c232806b070eb8983949fb2645b">ProgramWriterMap</a> <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#af3058fc76343ef0a2e4490d7ff7409e3">Ogre::RTShader::ProgramManager::mProgramWritersMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00216">216</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="aff0baaaed91d8505cfb72b7725ae1c37"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::msSingleton" ref="aff0baaaed91d8505cfb72b7725ae1c37" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html">ProgramManager</a> * <a class="el" href="classOgre_1_1Singleton.html">Ogre::Singleton</a>&lt; <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html">ProgramManager</a>  &gt;::<a class="el" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">msSingleton</a><code> [static, protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSingleton_8h_source.html#l00075">75</a> of file <a class="el" href="OgreSingleton_8h_source.html">OgreSingleton.h</a>.</p>

</div>
</div>
<a class="anchor" id="a91ebd2a26c267914c4dbec827786ef65"></a><!-- doxytag: member="Ogre::RTShader::ProgramManager::mVertexShaderMap" ref="a91ebd2a26c267914c4dbec827786ef65" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a6cb4798f70d8d155a8fd38b3dc90db6f">GpuProgramsMap</a> <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html#a91ebd2a26c267914c4dbec827786ef65">Ogre::RTShader::ProgramManager::mVertexShaderMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramManager_8h_source.html#l00219">219</a> of file <a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShaderProgramManager_8h_source.html">OgreShaderProgramManager.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:33
</p>
</body>
</html>
